import { __classPrivateFieldGet } from 'tslib';
import { Subject, ReplaySubject } from 'rxjs';
import { shareReplay, withLatestFrom } from 'rxjs/operators';

var _DeferredValueAccessor_accessor, _DeferredValueAccessor_writeValue, _DeferredValueAccessor_registerOnChange, _DeferredValueAccessor_registerOnTouched, _DeferredValueAccessor_setDisabledState;
class DeferredValueAccessor {
    constructor() {
        this.subscriptions = [];
        _DeferredValueAccessor_accessor.set(this, new Subject());
        _DeferredValueAccessor_writeValue.set(this, new ReplaySubject());
        _DeferredValueAccessor_registerOnChange.set(this, new ReplaySubject());
        _DeferredValueAccessor_registerOnTouched.set(this, new ReplaySubject());
        _DeferredValueAccessor_setDisabledState.set(this, new ReplaySubject());
        const accessorSbj = __classPrivateFieldGet(this, _DeferredValueAccessor_accessor, "f").pipe(shareReplay(1));
        this.subscriptions.push(__classPrivateFieldGet(this, _DeferredValueAccessor_writeValue, "f").pipe(withLatestFrom(accessorSbj)).subscribe(([val, accessor]) => accessor === null || accessor === void 0 ? void 0 : accessor.writeValue(val)), __classPrivateFieldGet(this, _DeferredValueAccessor_registerOnChange, "f").pipe(withLatestFrom(accessorSbj)).subscribe(([val, accessor]) => accessor === null || accessor === void 0 ? void 0 : accessor.registerOnChange(val)), __classPrivateFieldGet(this, _DeferredValueAccessor_registerOnTouched, "f").pipe(withLatestFrom(accessorSbj)).subscribe(([val, accessor]) => accessor === null || accessor === void 0 ? void 0 : accessor.registerOnTouched(val)), __classPrivateFieldGet(this, _DeferredValueAccessor_setDisabledState, "f").pipe(withLatestFrom(accessorSbj)).subscribe(([val, accessor]) => accessor === null || accessor === void 0 ? void 0 : accessor.setDisabledState(val)));
    }
    set valueAccessor(accessor) {
        __classPrivateFieldGet(this, _DeferredValueAccessor_accessor, "f").next(accessor);
    }
    writeValue(obj) {
        __classPrivateFieldGet(this, _DeferredValueAccessor_writeValue, "f").next(obj);
    }
    registerOnChange(fn) {
        __classPrivateFieldGet(this, _DeferredValueAccessor_registerOnChange, "f").next(fn);
    }
    registerOnTouched(fn) {
        __classPrivateFieldGet(this, _DeferredValueAccessor_registerOnTouched, "f").next(fn);
    }
    setDisabledState(isDisabled) {
        __classPrivateFieldGet(this, _DeferredValueAccessor_setDisabledState, "f").next(isDisabled);
    }
}
_DeferredValueAccessor_accessor = new WeakMap(), _DeferredValueAccessor_writeValue = new WeakMap(), _DeferredValueAccessor_registerOnChange = new WeakMap(), _DeferredValueAccessor_registerOnTouched = new WeakMap(), _DeferredValueAccessor_setDisabledState = new WeakMap();

/**
 * Generated bundle index. Do not edit.
 */

export { DeferredValueAccessor };
//# sourceMappingURL=ngx-reactive-form-utils-deferred-value-accessor.js.map
